## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:           gzdoom
Version:        4.13.2
Release:        %autorelease
Summary:	GZDoom is a modder-friendly OpenGL and Vulkan source port based on the DOOM engine

License:        GPL-3.0-or-later
URL:            https://github.com/ZDoom/gzdoom
Source0:	%{url}/archive/refs/tags/g%{version}.tar.gz
Source1:	gzdoom.desktop
Source2:	gzdoom.metainfo.xml
Source3:	gzdoom_48x48.png
Source4:	gzdoom_64x64.png
Source5:	gzdoom_128x128.png

BuildRequires:	g++
BuildRequires:	cmake
BuildRequires:	bzip2-devel
BuildRequires:	libvpx-devel
BuildRequires:	SDL2-devel
BuildRequires:	gtk3-devel
BuildRequires:	asmjit-devel
BuildRequires:	openal-soft-devel
BuildRequires:	zmusic-devel

BuildRequires:	desktop-file-utils
BuildRequires:	libappstream-glib

%description
GZDoom is a feature centric port for all Doom engine games, based on ZDoom,
adding an OpenGL renderer and powerful scripting capabilities

%prep
%autosetup -n %{name}-g%{version}

# DUMB license belongs to ZMusic
rm docs/licenses/dumb.txt

rm -rf libraries/bzip2

# we do not build from VCS so we have to improvise :)
{
	echo "// 0"
	echo "#define GIT_DESCRIPTION \"g%{VERSION}\""
	echo "#define GIT_HASH \"0\""
	echo "#define GIT_TIME \"0\""
} > src/gitinfo.h
cat src/gitinfo.h

%build
# doesn't build without it using RHEL flags :shrug:
export COMMON_FLAGS="-fPIC"

%cmake	-DBUILD_SHARED_LIBS=OFF			\
	-DCMAKE_C_FLAGS="$COMMON_FLAGS" 	\
	-DCMAKE_CXX_FLAGS="$COMMON_FLAGS"	\
	-DFORCE_INTERNAL_BZIP2=OFF		\
	-DFORCE_INTERNAL_ASMJIT=OFF		\
	-DDYN_OPENAL=OFF
cat src/gitinfo.h

%cmake_build

%install
%cmake_install

# licenses goes to other place
rm -vrf %{buildroot}%{_docdir}/gzdoom/licenses

desktop-file-install --dir %{buildroot}%{_datadir}/applications %{SOURCE1}

install -m 0644 -vd %{buildroot}%{_metainfodir}
install -m 0644 -vpT %{SOURCE2} %{buildroot}%{_metainfodir}/gzdoom.metainfo.xml

install -m 0644 -vd %{buildroot}%{_datadir}/icons/hicolor/48x48/apps
install -m 0644 -vpT %{SOURCE3} %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/gzdoom.png

install -m 0644 -vd %{buildroot}%{_datadir}/icons/hicolor/64x64/apps
install -m 0644 -vpT %{SOURCE4} %{buildroot}%{_datadir}/icons/hicolor/64x64/apps/gzdoom.png

install -m 0644 -vd %{buildroot}%{_datadir}/icons/hicolor/128x128/apps
install -m 0644 -vpT %{SOURCE5} %{buildroot}%{_datadir}/icons/hicolor/128x128/apps/gzdoom.png


%check
desktop-file-validate %{buildroot}/%{_datadir}/applications/gzdoom.desktop
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/*.metainfo.xml
%ctest

%files
%license docs/licenses/*
%{_bindir}/gzdoom
%{_docdir}/gzdoom/console.css
%{_docdir}/gzdoom/console.html
%{_docdir}/gzdoom/rh-log.txt
%{_docdir}/gzdoom/skins.txt
%{_datadir}/games/doom/brightmaps.pk3
%{_datadir}/games/doom/fm_banks/GENMIDI.GS.wopl
%{_datadir}/games/doom/fm_banks/gs-by-papiezak-and-sneakernets.wopn
%{_datadir}/games/doom/game_support.pk3
%{_datadir}/games/doom/game_widescreen_gfx.pk3
%{_datadir}/games/doom/gzdoom.pk3
%{_datadir}/games/doom/lights.pk3
%{_datadir}/games/doom/soundfonts/gzdoom.sf2
%{_datadir}/icons/hicolor/48x48/apps/gzdoom.png
%{_datadir}/icons/hicolor/64x64/apps/gzdoom.png
%{_datadir}/icons/hicolor/128x128/apps/gzdoom.png
%{_datadir}/applications/gzdoom.desktop
%{_metainfodir}/gzdoom.metainfo.xml

%changelog
## START: Generated by rpmautospec
* Tue Dec 17 2024 John Doe <packager@example.com> - 4.13.2-1
- Uncommitted changes
## END: Generated by rpmautospec
